﻿/// <reference path="lib/jquery-3.2.0.min.js" />
/** GS Loader 
 *  version: 1.2
 *  latest update: 2018/07/03
 */
(function (path, window, document, pageInit) {

    //path bug fixed
    if (path.length && path.substr(path.length - 1, 1) != "/") {
        path = path.substr(0, path.lastIndexOf("/") + 1);
    }

    /*  
     *  #jQuery version
     *
     *  AORUS: 1.12.3
     *  GIGABYTE: 1.12.4   
     */
    var $$ = window.jQuery;
    var gs = window.gs = {
        path: path,
        
        resolvePath: function (str) {
            if (str && str.length > 0) {
                if (str.substr(0, 5) == "http:" || str.substr(0, 6) == "https:" || str.substr(0, 2) == "//" || str.substr(0,1) == "#") {
                    return str;
                } else if (str.substr(0, 1) == "/") {
                    str = str.substr(1);
                }
            }
            return path + str;
        },
        resolveAttrPath: function (selector, attr) {
            var el = $$(selector);

            el.find('[' + attr + ']').each(function () {
                $(this).attr(attr, gs.resolvePath($(this).attr(attr)));
            });
        },
        addCSSlink: function (src) {
            var cssdom = document.createElement("link");
            cssdom.href = src;
            cssdom.rel = "stylesheet";
            cssdom.type = "text/css";
            $$("head").append(cssdom);
        },
        addScript: function (src) {
            var scriptdom = document.createElement("script");
            scriptdom.type = "text/javascript";
            scriptdom.src = src;
            $$("head").append(scriptdom);
        },
    };

    //預設載入/css/style.css檔
    gs.addCSSlink(gs.resolvePath('css/style.css'));
    
    var pageInfo = gs.pageInfo = {};
    pageInfo.version = 1;
    pageInfo.isAORUS = window.location.hostname.indexOf('aorus') != -1;
    pageInfo.productName = $('.model-name-container, #pdif_title .g_font_xg').text().trim();
    pageInfo.brand = pageInfo.isAORUS ? "aorus" : "gigabyte";
    pageInfo.pid = pageInfo.isAORUS ? /p=(\d+)/.exec(window.location.href)[1] : $('input#isPid').val();

    /** GS ScrollTracking 
     *  version: 1.0
     *  latest update: 2018/07/03
     */
    (function (window) {
        "use strict";

        var baseline,
            eventCategory,
            eventAction,

            document = window.document,

            maxScrollLevel = 0,
            level = 10,
            _init = false,
            callback = function () { };


        function init() {
            _init = true;
        }

        function send(a, b, c) {
            'ga' in window && window['ga']("send", "event", a, b, c);
        }

        function calculateBaseline() {
            baseline = window.innerHeight * .3
        }

        function scroll() {
            var step, scrollLevel, scrollTop, a, label;

            if (!_init) return;

            scrollTop = document.documentElement && document.documentElement.scrollTop || document.body.scrollTop;
            baseline = document.body.scrollHeight - (window.innerHeight || document.documentElement.clientHeight);

            step = 1;
            scrollLevel = Math.floor(scrollTop / baseline * level);

            if (scrollLevel > maxScrollLevel)
                for (; step <= scrollLevel && step <= level; step++) {
                    if (step > maxScrollLevel) {
                        label = step / level * 100 + "%";
                        maxScrollLevel = step;
                        send(eventCategory, eventAction, label);
                        callback(eventCategory, eventAction, label);
                    }
                }
        }

        function scrollTracking(category, action) {
            eventCategory = category;
            eventAction = action;

            if (_init) {
                init();
            }
        }

        $$(window).on('load', function () { init(); });
        $$(window).on('scroll', scroll);
        $$(window).on('resize', calculateBaseline);

        gs.ScrollTracking = scrollTracking;
        gs.ScrollTrackingCallback = function (fn) { callback = fn };

    })(window);

    function init() {
        pageInit.call(window, gs);

        //執行scroll tracking
        gs.ScrollTracking('FeatureScroll', gs.pageInfo.productName);
    }

    function handleLoader(elem) {
        elem.find('[gs-loader]').each(function () {
            var name = this.tagName.toLowerCase();

            switch (name) {
                case "link":
                    gs.addCSSlink(path + $$(this).attr("href"));
                    break;
                case "script":
                    gs.addScript(path + $$(this).attr("src"));
                    break;
                default:
                    $$('body').append(this);
                    break;
            };
        });
    }

    $.ajax({
        url: 'main.html',
        dataType: 'html',
        success: function (data) {
            var div = $$('<div>'),
                html = data,
                iframe = $$('#iframe_kf, #kf-iframe'),
                elem;

            //自動載入header的gs-loader標籤
            if (~(html.indexOf('<head')) && ~(html.indexOf('<\/head>'))) {
                var headstr = /\<head[^\>]*>([\s\S]*)(?:<\/head>)/.exec(data)[1];
                var head = $$('<div>');
                head.html(headstr);
                handleLoader(head);
            }

            if (~(html.indexOf('<body')) && ~(html.indexOf('<\/body>'))) {
                html = /\<body[^\>]*>([\s\S]*)(?:<\/body>)/.exec(data)[1];
            }

            div.html(html);
            gs.resolveAttrPath(div, 'src');
            gs.resolveAttrPath(div, 'href');

            elem = div.children();

            if (iframe.length) {
                iframe.after(elem);
            } else {
                $('body').append(elem);
            }

            init();
            iframe.hide();
        }
    });

})(window.location.pathname, window = (window.top || window), window.document, _GS_INIT);