﻿/// <reference path="lib/jquery-2.1.4.js" />
var _GS_INIT = function (path) {
    var window = this,
        document = window.document,
        gs = window.gs,
        $ = window.jQuery,
        path = "";

    if (gs) {
        path = gs.path;
        //手動加上外層的css或js                        
        //gs.addCSSlink(gs.resolvePath('css/style.css'));
    }

    //scrollTop fn
    (function (window) { var i, n, t; i = "pageYOffset" in window; n = { scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }; for (t in n) window[t] = function (t, r) { var u = r === n.scrollTop; return function (n) { if (typeof n == "undefined") return i ? window[r] : document.documentElement[t] || document.body[t] || 0; window.scrollTo(u ? window.scrollLeft() : n, u ? n : window.scrollTop()) } }(t, n[t]) })(window);

    path = path || "";

    function main() {

        //導航列
        nav();

        //gsync pic
        gsync();

        scrollAnchor()
    }

    function nav() {
        var list = [];
        var listContainer = $('#kf-nav');
        var items = $('[data-nav]');
        var header = $('#kf-header');
        //偏差y值: 用於保留header
        var pd;
        //最後y值: 依y值差推定捲動方向
        var lastst;

        function init() {
            //初始化元素，加入導覽項目
            items.each(function () {
                add($(this));
            });

            //更新y值，初始時代入初始設定，跳過隔離區
            update(true);

            //綁定事件
            listContainer.on('click', 'li[data-navto]', function () {
                var i = parseInt($(this).attr('data-navto'));

                to(i);
            });

            $(window).on('scroll', function () {
                update();

                lastst = window.scrollTop();
            });
            $(window).on('resize', update);
        }       
                

        function add(item) {
            var title = item.attr('data-nav');            
            var index = list.length;
            var nav = $('<li data-navto="'+index+'"><span>' + title + '</span></li>');

            listContainer.append(nav);
            list.push({
                index: index,
                title: title,
                elem: item,
                nav: nav
            });
        }

        function to(n) {
            $.each(list, function (i, data) {
                if (n == data.index) {
                    var top = data.top - pd + 1;

                    if (top < 0) top = 0;

                    $('html, body').stop().animate({ scrollTop: top }, 800, "swing");


                    return false;
                }
            });
        }

        function update(isInit) {
            pd = header.height();
            lastst = window.scrollTop();

            //更新區塊y值
            $.each(list, function (i, data) {
                var elem = data.elem;

                data.top = elem.offset().top;
            });

            //排序 依y值由小排到大
            list.sort(function (a, b) {
                if (a.top < b.top) {
                    return -1;
                }
                if (a.top > b.top) {
                    return 1;
                }
                return 0;
            });

            //更新y值後重新計算項目
            calc(isInit);
        }

        function calc(isInit) {
            var direction;
            var scrolltop = window.scrollTop();
            var _data;
            //偏差y值2: 所有區塊y值往上計算的數值內為隔離區
            //緩衝區塊改為隔離區，y值落於此區段不做任何計算，因緩衝區在上下移動時計算基準不同會有bug。            
            var pd2 = 500;
            //隔離狀態
            var _ex = false;                        

            //方向 true: 下; false: 上;
            direction = !(scrolltop < lastst);                        
                  
            //抓區塊設定
            $.each(list, function (i, data) {
                //判斷是否為隔離區
                if ((scrolltop + pd + pd2) >= data.top && (scrolltop + pd < data.top)) {
                    _ex = true;
                }
                
                if (scrolltop + pd < data.top) {
                    return false;
                }

                _data = data;
            });

            //隔離區不做任何動作
            //初始狀態忽略隔離區設定 (修正重整bug)
            if (!isInit) {
                if (_ex) {
                    return;
                }
            }

            if(_data && _data.nav){
                _data.nav.addClass('active').siblings().removeClass('active');
            }
        }

        init();
    }

    function scrollAnchor() {
        var offset = 80;
        var container = $('#kf-container');

        container.on('click', 'a[href]', function (e) {
            var href = $(this).attr('href');

            if (href && href.substr(0, 1) == '#') {
                var target = $(href);

                if (target.length) {
                    e.preventDefault();

                    var top = target.offset().top - offset;

                    $('html, body').stop().animate({ scrollTop: top }, 800, "swing");
                }
            }
        });
    }

    function gsync() {
        var cover = $(".pic-cover");
        var bar = $('.pic-bar');
        var elem = $('.pic-after');
        var drag = false;



        function start(e) {
            drag = true;
            e.preventDefault();
        }
        function move(e) {
            if (!drag) return;

            var x = e.pageX;
            var ratio = (x - cover.offset().left) / cover.width();

            if (ratio > 1) ratio = 1;
            if (ratio < 0) ratio = 0;

            to(ratio);
        }
        function end() {
            drag = false;
        }
        function to(ratio) {
            var p = ratio * 100 + "%";

            bar.css('left', p);
            elem.css('width', p);
        }

        cover.on('mousedown', start);
        cover.on('touchstart', start);
        $(document).on('mousemove', move);
        $(document).on('touchmove', function (e) {
            e.preventDefault();
            move(e.originalEvent.touches[0]);
        });
        $(document).on('mouseup', end);
        $(document).on('touchend', end);

        to(0.5);
    }

    main();
};